package com.redhat.gss.reproducer;

import org.jboss.resteasy.client.ClientResponse;
import org.jboss.resteasy.client.ProxyFactory;
import org.jboss.resteasy.client.jaxrs.ResteasyClient;
import org.jboss.resteasy.client.jaxrs.ResteasyClientBuilder;

import javax.ws.rs.core.Response;
import java.io.*;

/**
 * Created by mkopecky on 4/21/17.
 */
public class NewClientTest {
    private static final String BASE_URL = "http://localhost:8080/RESTEASY-992-reproducer-1.0/rest/";

    @SuppressWarnings("unchecked")
    @org.junit.Test
    public void test() throws FileNotFoundException, IOException {
        ResteasyClient client = new ResteasyClientBuilder().build();
        ReceiveLargeObjectResource service = client.target(BASE_URL).proxy(ReceiveLargeObjectResource.class);

        String file = "receivedJBoss.zip";
        String filename = "/tmp/" + file;
        Response response = service.serveLargeObject(filename);
        try {
            try (BufferedOutputStream out = new BufferedOutputStream(
                    new FileOutputStream(file));
                 InputStream in = response
                         .readEntity(InputStream.class)) {
                int count;
                byte[] buffer = new byte[1024 * 8];
                long total = 0;
                int loop = 0;
                while ((count = in.read(buffer)) != -1) {
                    out.write(buffer, 0, count);
                    total += count;
                    if (loop++ % 2500 == 0) {
                        System.out.println("wrote total = " + total / 1024 / 1024
                                + " Mb");
                    }
                }
                System.out.println("transferred file with size: " + total);
            }
        } finally {
            response.close();
            client.close();
        }
    }

}
